// Generated by psc version 0.8.0.0
"use strict";
var $foreign = require("./foreign");
var Prelude = require("../Prelude");
var Data_Argonaut_Printer = require("../Data.Argonaut.Printer");
var Data_Argonaut_Parser = require("../Data.Argonaut.Parser");
var Data_Argonaut_Decode = require("../Data.Argonaut.Decode");
var Data_Argonaut_Encode = require("../Data.Argonaut.Encode");
var Data_Array = require("../Data.Array");
var Data_Array_Unsafe = require("../Data.Array.Unsafe");
var Data_Date = require("../Data.Date");
var Data_Either = require("../Data.Either");
var Data_Foldable = require("../Data.Foldable");
var Data_Traversable = require("../Data.Traversable");
var Data_StrMap = require("../Data.StrMap");
var Data_StrMap_ST = require("../Data.StrMap.ST");
var Data_Maybe = require("../Data.Maybe");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console = require("../Control.Monad.Eff.Console");
var Control_Monad_Eff_Exception = require("../Control.Monad.Eff.Exception");
var Control_Monad_ST = require("../Control.Monad.ST");
var Control_Apply = require("../Control.Apply");
var Control_Monad = require("../Control.Monad");
var Node_Process = require("../Node.Process");
var Node_ChildProcess = require("../Node.ChildProcess");
var Node_Stream = require("../Node.Stream");
var Node_Buffer = require("../Node.Buffer");
var Node_Encoding = require("../Node.Encoding");
var Node_FS = require("../Node.FS");
var Node_FS_Sync = require("../Node.FS.Sync");
var Node_FS_Stats = require("../Node.FS.Stats");
var Node_Path = require("../Node.Path");
var Unsafe_Coerce = require("../Unsafe.Coerce");
var Psa = require("../Psa");
var Psa_Printer_Default = require("../Psa.Printer.Default");
var Psa_Types = require("../Psa.Types");
var Psa_Output = require("../Psa.Output");
var Data_Posix_Signal = require("../Data.Posix.Signal");
var usage = "psa - Error/Warning reporting frontend for psc \n\nUsage: psa [--censor-lib] [--censor-src]\n           [--censor-codes=CODES] [--filter-codes=CODES]\n           [--no-colors] [--no-source]\n           [--is-lib=DIR] [--psc=PSC] [--stash]\n           PSC_OPTIONS\n\nAvailable options:\n  -v,--version           Show the version number\n  -h,--help              Show this help text\n  --verbose-stats        Show counts for each warning type\n  --censor-warnings      Censor all warnings\n  --censor-lib           Censor warnings from library sources\n  --censor-src           Censor warnings from project sources\n  --censor-codes=CODES   Censor specific error codes\n  --filter-codes=CODES   Only show specific error codes\n  --no-colors            Disable ANSI colors\n  --no-source            Disable original source code printing\n  --strict               Promotes src warnings to errors\n  --stash                Enable persistent warnings (defaults to .psa-stash)\n  --stash=FILE           Enable persistent warnings using a specific stash file\n  --is-lib=DIR           Distinguishing library path (defaults to 'bower_components')\n  --psc=PSC              Name of psc executable (defaults to 'psc')\n\n  CODES                  Comma-separated list of psc error codes\n  PSC_OPTIONS            Any extra options are passed to psc\n";
var parseOptions = function (opts) {
    return function (args) {
        var isPrefix = function (s) {
            return function (str) {
                var $24 = Data_String.indexOf(s)(str);
                if ($24 instanceof Data_Maybe.Just && $24.value0 === 0) {
                    return true;
                };
                return false;
            };
        };
        var parse = function (p) {
            return function (arg) {
                if (arg === "--version" || arg === "-v") {
                    return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log($foreign.version))(Node_Process.exit(0));
                };
                if (arg === "--help" || arg === "-h") {
                    return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log(usage))(Node_Process.exit(0));
                };
                if (arg === "--stash") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $28 = {};
                        for (var $29 in p) {
                            if (p.hasOwnProperty($29)) {
                                $28[$29] = p[$29];
                            };
                        };
                        $28.stash = true;
                        return $28;
                    })());
                };
                if (arg === "--no-source") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $30 = {};
                        for (var $31 in p) {
                            if (p.hasOwnProperty($31)) {
                                $30[$31] = p[$31];
                            };
                        };
                        $30.showSource = false;
                        return $30;
                    })());
                };
                if (arg === "--no-colors" || arg === "--monochrome") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $34 = {};
                        for (var $35 in p) {
                            if (p.hasOwnProperty($35)) {
                                $34[$35] = p[$35];
                            };
                        };
                        $34.opts = (function () {
                            var $32 = {};
                            for (var $33 in p.opts) {
                                if (p.opts.hasOwnProperty($33)) {
                                    $32[$33] = p.opts[$33];
                                };
                            };
                            $32.ansi = false;
                            return $32;
                        })();
                        return $34;
                    })());
                };
                if (arg === "--verbose-stats") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $38 = {};
                        for (var $39 in p) {
                            if (p.hasOwnProperty($39)) {
                                $38[$39] = p[$39];
                            };
                        };
                        $38.opts = (function () {
                            var $36 = {};
                            for (var $37 in p.opts) {
                                if (p.opts.hasOwnProperty($37)) {
                                    $36[$37] = p.opts[$37];
                                };
                            };
                            $36.verboseStats = true;
                            return $36;
                        })();
                        return $38;
                    })());
                };
                if (arg === "--strict") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $42 = {};
                        for (var $43 in p) {
                            if (p.hasOwnProperty($43)) {
                                $42[$43] = p[$43];
                            };
                        };
                        $42.opts = (function () {
                            var $40 = {};
                            for (var $41 in p.opts) {
                                if (p.opts.hasOwnProperty($41)) {
                                    $40[$41] = p.opts[$41];
                                };
                            };
                            $40.strict = true;
                            return $40;
                        })();
                        return $42;
                    })());
                };
                if (arg === "--censor-warnings") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $46 = {};
                        for (var $47 in p) {
                            if (p.hasOwnProperty($47)) {
                                $46[$47] = p[$47];
                            };
                        };
                        $46.opts = (function () {
                            var $44 = {};
                            for (var $45 in p.opts) {
                                if (p.opts.hasOwnProperty($45)) {
                                    $44[$45] = p.opts[$45];
                                };
                            };
                            $44.censorWarnings = true;
                            return $44;
                        })();
                        return $46;
                    })());
                };
                if (arg === "--censor-lib") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $50 = {};
                        for (var $51 in p) {
                            if (p.hasOwnProperty($51)) {
                                $50[$51] = p[$51];
                            };
                        };
                        $50.opts = (function () {
                            var $48 = {};
                            for (var $49 in p.opts) {
                                if (p.opts.hasOwnProperty($49)) {
                                    $48[$49] = p.opts[$49];
                                };
                            };
                            $48.censorLib = true;
                            return $48;
                        })();
                        return $50;
                    })());
                };
                if (arg === "--censor-lib") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $54 = {};
                        for (var $55 in p) {
                            if (p.hasOwnProperty($55)) {
                                $54[$55] = p[$55];
                            };
                        };
                        $54.opts = (function () {
                            var $52 = {};
                            for (var $53 in p.opts) {
                                if (p.opts.hasOwnProperty($53)) {
                                    $52[$53] = p.opts[$53];
                                };
                            };
                            $52.censorLib = true;
                            return $52;
                        })();
                        return $54;
                    })());
                };
                if (arg === "--censor-src") {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $58 = {};
                        for (var $59 in p) {
                            if (p.hasOwnProperty($59)) {
                                $58[$59] = p[$59];
                            };
                        };
                        $58.opts = (function () {
                            var $56 = {};
                            for (var $57 in p.opts) {
                                if (p.opts.hasOwnProperty($57)) {
                                    $56[$57] = p.opts[$57];
                                };
                            };
                            $56.censorSrc = true;
                            return $56;
                        })();
                        return $58;
                    })());
                };
                if (isPrefix("--censor-codes=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $62 = {};
                        for (var $63 in p) {
                            if (p.hasOwnProperty($63)) {
                                $62[$63] = p[$63];
                            };
                        };
                        $62.opts = (function () {
                            var $60 = {};
                            for (var $61 in p.opts) {
                                if (p.opts.hasOwnProperty($61)) {
                                    $60[$61] = p.opts[$61];
                                };
                            };
                            $60.censorCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.censorCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $60;
                        })();
                        return $62;
                    })());
                };
                if (isPrefix("--filter-codes=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $66 = {};
                        for (var $67 in p) {
                            if (p.hasOwnProperty($67)) {
                                $66[$67] = p[$67];
                            };
                        };
                        $66.opts = (function () {
                            var $64 = {};
                            for (var $65 in p.opts) {
                                if (p.opts.hasOwnProperty($65)) {
                                    $64[$65] = p.opts[$65];
                                };
                            };
                            $64.filterCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.filterCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                            return $64;
                        })();
                        return $66;
                    })());
                };
                if (isPrefix("--is-lib=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $70 = {};
                        for (var $71 in p) {
                            if (p.hasOwnProperty($71)) {
                                $70[$71] = p[$71];
                            };
                        };
                        $70.opts = (function () {
                            var $68 = {};
                            for (var $69 in p.opts) {
                                if (p.opts.hasOwnProperty($69)) {
                                    $68[$69] = p.opts[$69];
                                };
                            };
                            $68.libDirs = Data_Array.snoc(p.opts.libDirs)(Data_String.drop(9)(arg));
                            return $68;
                        })();
                        return $70;
                    })());
                };
                if (isPrefix("--psc=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $72 = {};
                        for (var $73 in p) {
                            if (p.hasOwnProperty($73)) {
                                $72[$73] = p[$73];
                            };
                        };
                        $72.psc = Data_String.drop(6)(arg);
                        return $72;
                    })());
                };
                if (isPrefix("--stash=")(arg)) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $74 = {};
                        for (var $75 in p) {
                            if (p.hasOwnProperty($75)) {
                                $74[$75] = p[$75];
                            };
                        };
                        $74.stash = true;
                        $74.stashFile = Data_String.drop(8)(arg);
                        return $74;
                    })());
                };
                if (Prelude.otherwise) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                        var $76 = {};
                        for (var $77 in p) {
                            if (p.hasOwnProperty($77)) {
                                $76[$77] = p[$77];
                            };
                        };
                        $76.extra = Data_Array.snoc(p.extra)(arg);
                        return $76;
                    })());
                };
                throw new Error("Failed pattern match at Main line 97, column 1 - line 102, column 1: " + [ p.constructor.name, arg.constructor.name ]);
            };
        };
        var defaultLibDir = function (x) {
            if (Data_Array.length(x.opts.libDirs) === 0) {
                var $81 = {};
                for (var $82 in x) {
                    if (x.hasOwnProperty($82)) {
                        $81[$82] = x[$82];
                    };
                };
                $81.opts = (function () {
                    var $79 = {};
                    for (var $80 in x.opts) {
                        if (x.opts.hasOwnProperty($80)) {
                            $79[$80] = x.opts[$80];
                        };
                    };
                    $79.libDirs = [ "bower_components" ];
                    return $79;
                })();
                return $81;
            };
            if (Prelude.otherwise) {
                return x;
            };
            throw new Error("Failed pattern match at Main line 97, column 1 - line 102, column 1: " + [ x.constructor.name ]);
        };
        return Prelude["<$>"](Control_Monad_Eff.functorEff)(defaultLibDir)(Data_Array.foldM(Control_Monad_Eff.monadEff)(parse)({
            extra: [  ], 
            psc: "psc", 
            showSource: true, 
            stash: false, 
            stashFile: ".psa-stash", 
            opts: opts
        })(args));
    };
};
var defaultOptions = {
    ansi: true, 
    censorWarnings: false, 
    censorLib: false, 
    censorSrc: false, 
    censorCodes: Data_Set.empty, 
    filterCodes: Data_Set.empty, 
    verboseStats: false, 
    libDirs: [  ], 
    strict: false, 
    cwd: ""
};

/**
 *  Due to `catchException` label annoyingness
 */
var catchException$prime = function (eb) {
    return function (eff) {
        return Unsafe_Coerce.unsafeCoerce(Control_Monad_Eff_Exception.catchException(Unsafe_Coerce.unsafeCoerce(eb))(Unsafe_Coerce.unsafeCoerce(eff)));
    };
};
var main = (function () {
    
    /**
     *  TODO: Handle exceptions
     */
    var stdio = [ new Data_Maybe.Just(Node_ChildProcess.Pipe.value), Node_ChildProcess.inherit[1], new Data_Maybe.Just(Node_ChildProcess.Pipe.value) ];
    var mergeWarnings = function (filenames) {
        return function (date) {
            return function (old) {
                return function ($$new) {
                    return function __do() {
                        var v = Data_StrMap_ST["new"]();
                        var v1 = Prelude.flip(Data_Array.filterM(Control_Monad_Eff.monadEff))(old)(function (x) {
                            if (x.filename instanceof Data_Maybe.Nothing) {
                                return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                            };
                            if (x.filename instanceof Data_Maybe.Just) {
                                var $85 = Data_Set.member(Prelude.ordString)(x.filename.value0)(filenames);
                                if ($85) {
                                    return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                                };
                                if (!$85) {
                                    return function __do() {
                                        var v1 = Data_StrMap_ST.peek(v)(x.filename.value0)();
                                        if (v1 instanceof Data_Maybe.Just) {
                                            return v1.value0;
                                        };
                                        if (v1 instanceof Data_Maybe.Nothing) {
                                            var v2 = catchException$prime(function (v2) {
                                                return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                                            })(Prelude["<$>"](Control_Monad_Eff.functorEff)(function ($134) {
                                                return Prelude[">"](Data_Date.ordDate)(date)(Node_FS_Stats.modifiedTime($134));
                                            })(Node_FS_Sync.stat(x.filename.value0)))();
                                            Data_StrMap_ST.poke(v)(x.filename.value0)(v2)();
                                            return v2;
                                        };
                                        throw new Error("Failed pattern match: " + [ v1.constructor.name ]);
                                    };
                                };
                                throw new Error("Failed pattern match at Main line 187, column 1 - line 188, column 1: " + [ $85.constructor.name ]);
                            };
                            throw new Error("Failed pattern match at Main line 187, column 1 - line 188, column 1: " + [ x.filename.constructor.name ]);
                        })();
                        return Prelude["<>"](Prelude.semigroupArray)(v1)($$new);
                    };
                };
            };
        };
    };
    var loadNothing = function (v) {
        return function (v1) {
            return Prelude.pure(Control_Monad_Eff.applicativeEff)(Data_Maybe.Nothing.value);
        };
    };
    var loadLines = function (files) {
        return function (filename) {
            return function (pos) {
                return function __do() {
                    var v = (function __do() {
                        var cache = Data_StrMap_ST.peek(files)(filename)();
                        if (cache instanceof Data_Maybe.Just) {
                            return cache.value0;
                        };
                        if (cache instanceof Data_Maybe.Nothing) {
                            var v = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(filename))();
                            Data_StrMap_ST.poke(files)(filename)(v)();
                            return v;
                        };
                        throw new Error("Failed pattern match at Main line 187, column 1 - line 188, column 1: " + [ cache.constructor.name ]);
                    })();
                    var source = Data_Array.slice(pos.startLine - 1)(pos.endLine)(v);
                    return new Data_Maybe.Just(source);
                };
            };
        };
    };
    var insertFilenames = Data_Foldable.foldr(Data_Foldable.foldableArray)(function (x) {
        return function (s) {
            return Data_Maybe.maybe(s)(Prelude.flip(Data_Set.insert(Prelude.ordString))(s))(x.filename);
        };
    });
    var encodeStash = function (s) {
        return Data_Argonaut_Encode.encodeJson(Data_Argonaut_Encode.encodeJsonArray(Data_Argonaut_Encode.encodeJsonJson))(Prelude["<$>"](Prelude.functorArray)(Psa_Types.encodePsaError)(s));
    };
    var writeStashFile = function (stashFile) {
        return function (warnings) {
            var file = Data_Argonaut_Printer.printJson(Data_Argonaut_Printer.printerString)(encodeStash(warnings));
            return Node_FS_Sync.writeTextFile(Node_Encoding.UTF8.value)(stashFile)(file);
        };
    };
    var emptyStash = Prelude["<$>"](Control_Monad_Eff.functorEff)(function (v) {
        return {
            date: v, 
            stash: [  ]
        };
    })(Data_Date.now);
    var decodeStash = function (s) {
        return Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(s))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeArray(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson)))))(Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Either.applicativeEither)(Psa_Types.parsePsaError));
    };
    var readStashFile = function (stashFile) {
        return catchException$prime(Prelude["const"](emptyStash))(function __do() {
            var v = Node_FS_Sync.stat(stashFile)();
            var v1 = Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(stashFile)();
            var $99 = decodeStash(v1);
            if ($99 instanceof Data_Either.Left) {
                return emptyStash();
            };
            if ($99 instanceof Data_Either.Right) {
                return {
                    date: Node_FS_Stats.modifiedTime(v), 
                    stash: $99.value0
                };
            };
            throw new Error("Failed pattern match at Main line 187, column 1 - line 188, column 1: " + [ $99.constructor.name ]);
        });
    };
    return Prelude["void"](Control_Monad_Eff.functorEff)(function __do() {
        var v = Node_Process.cwd();
        var v1 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Array.drop(2))(Node_Process.argv)();
        var v2 = parseOptions((function () {
            var $104 = {};
            for (var $105 in defaultOptions) {
                if (defaultOptions.hasOwnProperty($105)) {
                    $104[$105] = defaultOptions[$105];
                };
            };
            $104.cwd = v;
            return $104;
        })())(v1)();
        var opts$prime = (function () {
            var $107 = {};
            for (var $108 in v2.opts) {
                if (v2.opts.hasOwnProperty($108)) {
                    $107[$108] = v2.opts[$108];
                };
            };
            $107.libDirs = Prelude["<$>"](Prelude.functorArray)(function ($135) {
                return (function (v3) {
                    return v3 + Node_Path.sep;
                })(Node_Path.resolve([ v ])($135));
            })(v2.opts.libDirs);
            return $107;
        })();
        var v3 = readStashFile(v2.stashFile)();
        var v4 = Node_ChildProcess.spawn(v2.psc)(Data_Array.cons("--json-errors")(v2.extra))((function () {
            var $110 = {};
            for (var $111 in Node_ChildProcess.defaultSpawnOptions) {
                if (Node_ChildProcess.defaultSpawnOptions.hasOwnProperty($111)) {
                    $110[$111] = Node_ChildProcess.defaultSpawnOptions[$111];
                };
            };
            $110.stdio = stdio;
            return $110;
        })())();
        var v5 = Control_Monad_ST.newSTRef("")();
        Node_Stream.onDataString(Node_ChildProcess.stderr(v4))(Node_Encoding.UTF8.value)(function (chunk) {
            return Prelude["void"](Control_Monad_Eff.functorEff)(Control_Monad_ST.modifySTRef(v5)(function (v6) {
                return v6 + chunk;
            }));
        })();
        return Node_ChildProcess.onExit(v4)(function (status) {
            if (status instanceof Node_ChildProcess.Normally) {
                return function __do() {
                    var v6 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Control_Monad_ST.readSTRef(v5))();
                    Data_Foldable.for_(Control_Monad_Eff.applicativeEff)(Data_Foldable.foldableArray)(v6)(function (err) {
                        var $116 = Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(err))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson))))(Psa_Types.parsePsaResult);
                        if ($116 instanceof Data_Either.Left) {
                            return Control_Monad_Eff_Console.error(err);
                        };
                        if ($116 instanceof Data_Either.Right) {
                            return function __do() {
                                var v7 = Data_StrMap_ST["new"]();
                                var loadLinesImpl = (function () {
                                    if (v2.showSource) {
                                        return loadLines(v7);
                                    };
                                    if (!v2.showSource) {
                                        return loadNothing;
                                    };
                                    throw new Error("Failed pattern match at Main line 219, column 19 - line 220, column 15: " + [ v2.showSource.constructor.name ]);
                                })();
                                var filenames = insertFilenames(insertFilenames(Data_Set.empty)($116.value0.errors))($116.value0.warnings);
                                var v8 = mergeWarnings(filenames)(v3.date)(v3.stash)($116.value0.warnings)();
                                var v9 = Psa_Output.output(Control_Monad_Eff.monadEff)(loadLinesImpl)(opts$prime)((function () {
                                    var $121 = {};
                                    for (var $122 in $116.value0) {
                                        if ($116.value0.hasOwnProperty($122)) {
                                            $121[$122] = $116.value0[$122];
                                        };
                                    };
                                    $121.warnings = v8;
                                    return $121;
                                })())();
                                Control_Monad.when(Control_Monad_Eff.monadEff)(v2.stash)(writeStashFile(v2.stashFile)(v8))();
                                Psa_Printer_Default.print(opts$prime)(v9)();
                                var $124 = Data_StrMap.isEmpty(v9.stats.allErrors);
                                if ($124) {
                                    return Node_Process.exit(0)();
                                };
                                if (!$124) {
                                    return Node_Process.exit(1)();
                                };
                                throw new Error("Failed pattern match at Main line 187, column 1 - line 188, column 1: " + [ $124.constructor.name ]);
                            };
                        };
                        throw new Error("Failed pattern match at Main line 187, column 1 - line 188, column 1: " + [ $116.constructor.name ]);
                    })();
                    return Node_Process.exit(status.value0)();
                };
            };
            if (status instanceof Node_ChildProcess.BySignal) {
                return function __do() {
                    Control_Monad_Eff_Console.error(Prelude.show(Data_Posix_Signal.showSignal)(status.value0))();
                    return Node_Process.exit(1)();
                };
            };
            throw new Error("Failed pattern match at Main line 187, column 1 - line 188, column 1: " + [ status.constructor.name ]);
        })();
    });
})();
module.exports = {
    "catchException'": catchException$prime, 
    main: main, 
    parseOptions: parseOptions, 
    defaultOptions: defaultOptions, 
    usage: usage, 
    version: $foreign.version
};
